<?php
/**
 * Dupechecker Version 1.1
 * 
 * Plugin written by Jayhunter for
 * 
 * Coppermine Photo Gallery
 * Coppermine version: 1.5.xx
 *
 **************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 **************************************************
 */

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['perm_denied'], __FILE__, __LINE__);
}

require_once('plugins/dupechecker/init.inc.php');

global $CONFIG, $lang_common;
$superCage = Inspekt::makeSuperCage();



list($timestamp, $form_token) = getFormToken();

// get sanitized POST parameters
if ($superCage->get->keyExists('update_delay') && $superCage->get->keyExists('update_images_per_request')) {

    $delay = $superCage->get->getInt('update_delay');
    $count = $superCage->get->getInt('update_images_per_request');

    $res = cpg_db_query ("SELECT pid, md5, filepath, filename FROM {$CONFIG['TABLE_PICTURES']} WHERE md5='' LIMIT {$count}");

    $num_rows = $res->numRows();


    if (!$num_rows) {
        echo "Nothing to update<br />";
    } else {
        echo '<html><head><meta http-equiv="refresh" content="' . $delay . '"></head><body>';
        echo "Updating $num_rows images ... <br /><br />";

        while ($row = $res->fetchAssoc()) {
            $path_to_image = $CONFIG['fullpath'] . $row['filepath'] . $row['filename'];
            $md5 = md5_file ($path_to_image);
            $update_query = "UPDATE {$CONFIG['TABLE_PICTURES']} SET md5='{$md5}' WHERE pid='{$row['pid']}'";
            cpg_db_query ($update_query);
            echo "Updated picture: $path_to_image ({$row['pid']}) with MD5 $md5<br />";
            //echo "$update_query<br /><br />";
        }
        echo 'Waiting ' . $delay . ' seconds ..</body></html>';
    }



} else {
    pageheader(sprintf($dupechecker_lang['configure_plugin_x'], $dupechecker_lang['display_name']));

    // start form
    echo <<< EOT
	<form name="cpgform" id="cpgform" method="get">
EOT;

    starttable('100%',  $dupechecker_lang['update_missing_hashes'], 2, 'cpg_zebra');	

    echo <<< EOT
      <tr>
        <td class="tableb">{$dupechecker_lang['update_images_per_request']}<hr /></td>
        <td>
            <input type="text" name="update_images_per_request" id="update_images_per_request" class="text" value="30" />
            <label for="update_images_per_request" class="clickable_option"></label>
        </td>
      </tr>
      <tr>
        <td class="tableb">{$dupechecker_lang['update_delay']}<hr /></td>
        <td>
            <input type="text" name="update_delay" id="update_delay" class="text" value="2" />
            <label for="update_delay" class="clickable_option"></label>
        </td>
      </tr>
EOT;

    echo <<< EOT
			<tr>
				<td class="tableb" align="center" colspan="2"><br /><br />
					<span>
					<input type="hidden" name="file" value="dupechecker/admin" />
					<input type="submit" name="submit" value="{$dupechecker_lang['update_missing_hashes']}" /> 
					</span>
				</td>
			</tr>
		</td>		
EOT;

    endtable();
    echo <<< EOT
	</form>
EOT;


    pagefooter();
    ob_end_flush();
}
